#   Maintained By: Tom Cowan tom@ssdllc.biz
#                  Synergy Software Design,llc
# 
#   Client: Brian Beasley, US NAVY NFESC DET
#   Compliant Geoprocessing script for calling executables
#
#   revision 1.5
# #########################################################################
# DATABASE PATH
dbPath = "" #"F:\\U_FOUO\\GEOPROCESSES\\USNRR\\u_fouo_usnrr_master_database.mdb" #10.mdb" #was 1.7

# PATH TO EXE FILE
exePath = "F:\\U_FOUO\\GEOPROCESSES\\USNRR\\SSDgeoprocHandler.exe"
#exePath = "F:\\U_FOUO\\GEOPROCESSES\\USNRR\\GeoProcHandler.exe"

# XML FILE WITH DB NAME-PATH PAIRS
xmlPath = "F:\\U_FOUO\\GEOPROCESSES\\USNRR\\usnrr_db.xml"
# #########################################################################


# Import system modules
import sys, string, os, arcgisscripting, binascii, win32pipe 
from transformTools import transfExtents, containsAll
from xml.dom.minidom import parse

# Create the Geoprocessor object
gp = arcgisscripting.create() #9.3)

# ######################## DEFINE FUNCTIONS BELOW ############################
def runEXE(in_param):
    # Create Command As Follows: [.exe file] [input param passed in by Flex widget] [database path]
    cmd =  exePath + " " + in_param + " " + dbPath;

    # Execute Command - open stdout pseudo file in textmode 't' or 'b' for binary objects
    (stdin,stdout) = win32pipe.popen4( cmd, 't' );

    # Handle objects returned from exe
    stdin.close(); 
    returnedFromEXE = stdout.read();
    try:
        exitcode = stdout.close() or 0;
    except IOError:
        print '<?xml version="1.0" encoding="UTF-8" ?><fault><type>PYTHON EXECUTE ERROR</type><error>There is a server error. Please contact your administrator with the information provided in this message.</error></fault>';
        exitcode = ( -1 );
    finally:
        # Send the exeReturnValue back to the Flex Widget
        #gp.SetParameterAsText(1,returnedFromEXE)
        print returnedFromEXE
        return returnedFromEXE

# By default, this splits the file in megabyte-sized chunks:  size=1024*1024
def getchunks(file, size=1024):
    f = open(file,"rb")
    while 1:
        start = f.tell()
        f.seek(size, 1)
        s = f.readline()
        yield start, f.tell() - start
        if not s:
            break
# ######################## DEFINE FUNCTIONS ABOVE ############################


# Get Input Parameter Passed In By The Flex Widget
inParam = gp.GetParameterAsText(0);
#inParam = "DigitalMediaLibraryWidget"
#nParam='FileTransfer^'
#inParam = "ce1cbe5d-8cf3-465f-aa2b-9ec900efad3e"

#EXAMPLE BELOW - VALUES ARE SEPARATED BY ^
#inParam = 'TransformExtents^PROJCS["World_Mercator",GEOGCS["GCS_WGS_1984",DATUM["D_WGS_1984",SPHEROID["WGS_1984",6378137.0,298.257223563]],PRIMEM["Greenwich",0.0],UNIT["Degree",0.0174532925199433]],PROJECTION["Mercator"],PARAMETER["False_Easting",0.0],PARAMETER["False_Northing",0.0],PARAMETER["Central_Meridian",-121.0],PARAMETER["Standard_Parallel_1",34.87],UNIT["Meter",1.0]]^-23112.5110711093,12482.4728892747,3364166.5618667,3411157.06227483'
#inParam = 'Identify^geodatabase3^9a37feb8-55c9-454f-a9fe-9eca010dde7d'
#inParam = 'Identify^u_fouo_usnrr_master_database^GET_IDENTIFY~7b29f29f-87c5-45ee-aea4-9eca010ddf00'

#IF VALUES ARE ^ SEPARATED THEN RUN CUSTOM ACTION - ELSE PASS PARAMETER TO THE EXE ENGINE
if (containsAll(inParam,'^')):
    theArr = [str(s) for s in inParam.split('^')]
    if (theArr[0] == 'TransformExtents'):
        gp.SetParameterAsText(1,transfExtents(theArr))
    elif (theArr[0] == 'Identify') or (theArr[0] == 'GetImages'):
        dbName = theArr[1]
        dbGUID = theArr[2]
        xmldoc = parse(xmlPath) #minidom.
        dbTag = xmldoc.getElementsByTagName(dbName) #'u_fouo_usnrr_master_database')
        if (len(dbTag) == 1):
            dbPath = dbTag[0].attributes['dbPath'].value
            gp.SetParameterAsText(1,runEXE(dbGUID))
            
    elif (theArr[0] == 'FileTransfer'):
        myFile = theArr[1]
        myFile = "F:\\U_FOUO\\GEOPROCESSES\\USNRR\\Bluhills.jpg"
        destinationFile =  str(gp.scratchWorkspace) + os.sep + "someFile3." + str(myFile).split('.')[len(str(myFile).split('.'))-1]
        #gp.Copy_management(myFile, destinationFile)
        gp.SetParameterAsText(1,myFile + ' => ' + destinationFile) #destinationFile)
        #retObj = gp.CreateObject("Array")
        #retStr = 0
        #retStr2 = "z"
        #for chunk in getchunks("F:\U_FOUO\USNRR\GEOPROCESSES\Bluehills.jpg"):
            #retStr+=1
            #retStr2 = str(chunk)
            #retObj.Add(retStr2)
            #print chunk
            #returnArr.Add(chunk);
        #f = open("F:\U_FOUO\USNRR\GEOPROCESSES\Bluehills.jpg", "rb") 
        #retStr=binascii.b2a_hex(f.read())
        #f.close()
        #gp.SetParameterAsText(0,retStr)
        #f = open("F:\U_FOUO\USNRR\GEOPROCESSES\Bluehills.jpg", "rb")    
        #retStr = f.read(1024)
        #retStr2 = retStr.decode() #.encode('utf-8')
        #f.close()
        #retObj = gp.CreateObject("Array")
        #retStr = ""
        #byte = f.read(1)      
        #while byte != "":                 
        #    byte = f.read(1024)
        #    retStr=retStr+str(byte)
            #returnArr.Add(byte)
        #f.close()
        #gp.SetParameter(0,returnArr)
        #gp.SetParameterAsText(0,retStr) #retObj.Count)
        #binFile = open('F:\U_FOUO\USNRR\GEOPROCESSES\Bluehills.jpg','rb')
        #open("filename", "rb").read()  for b in bytes_read:      process_byte(b)
        #binFile.close()
        #bytes_read = 
        #binFile = an_image.read()
        #an_image.close()
        #gp.SetParameterAsText(0,an_image_bytes)
        #an_image = open('C:\dev\Bluehills.jpg','rb')
        #theFile = os.open('Bluehills.jpg','rb')
        #byte_data = theFile.read()
        #theFile.close()
        #gp.SetParameterAsText(0,byte_data)
        #theFile = gp.CreateObject("File","F:\U_FOUO\USNRR\GEOPROCESSES\FileTransfer.zip");
        #gp.SetParameter(0,theFile);
        #gp.SetParameterAsText(0,transfExtents(theArr))
    else:
        gp.SetParameterAsText(1,runEXE(inParam))
else:
    gp.SetParameterAsText(1,runEXE(inParam))
        
